Package org.apache.uima.util.impl

# Class DataIO

java.lang.Object
org.apache.uima.util.impl.DataIO

public class DataIO extends Object
Methods for working with Data during I/O

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Charset`
  `UTF8`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DataIO()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static String`
  `decodeUTF8(ByteBuffer in, int length)`
  `static long`
  `lengthUTFv(String string)`
  `static int`
  `lengthVnumber(int v)`
  `static int`
  `lengthVnumber(long v)`
  `static int`
  `lengthVPNnumber(int v)`
  `static int`
  `lengthVPNnumber(long v)`
  `static byte[]`
  `readByteArray(DataInput in)`
  `static int[]`
  `readIntArray(DataInput in)`
  `static int[]`
  `readIntArrayDelta(DataInput in)`
  `static long[]`
  `readLongArray(DataInput in)`
  `static long[]`
  `readLongArrayDelta(DataInput in)`
  `static long`
  `readRestOfVlong(DataInput in, int firstByte)`
  `static int`
  `readUnsignedByte(DataInput in)`
  `static String`
  `readUTFv(DataInput in)`
  `static long`
  `readVlong(DataInput in)`
  `static int`
  `readVnumber(DataInput in)`
  `static void`
  `writeByte(DataOutput out, int v)`
  DataOutputStream writeByte with checking of argument
  `static void`
  `writeByteArray(DataOutput out, byte[] v)`
  `static void`
  `writeIntArray(DataOutput out, int[] v)`
  write array preceded by its length
  `static void`
  `writeIntArrayDelta(DataOutput out, int[] v)`
  Write delta encoded value, for increasing values
  `static void`
  `writeLongArray(DataOutput out, long[] v)`
  `static void`
  `writeLongArrayDelta(DataOutput out, long[] v)`
  `static void`
  `writeShort(DataOutput out, int v)`
  DataOutputStream writeShort with checking of argument
  `static void`
  `writeUnsignedByte(DataOutput out, int v)`
  Write lower 8 bits
  `static void`
  `writeUTFv(String string, DataOutput out)`
  Similar to writeUTF, but ok for strings > 32K bytes long and better for strings < 127 string utf-8 length must be ≤ Integer.MAX_VALUE - 1
  `static void`
  `writeVnumber(DataOutput out, int v)`
  Write a positive number with the fewest bytes possible up to 127 written as a byte high order bit on means get another byte Note: value treated as unsigned 32 bit int
  `static void`
  `writeVnumber(DataOutput out, long v)`
  Write a positive long with the fewest bytes possible; up to 127 written as a byte, high order bit on means get another byte.
  `static void`
  `writeVPNnumber(DataOutput out, int v)`
  write a positive or negative number, optimized for fewer bytes near 0 sign put in low order bit, rest of number converted to positive and shifted left 1 max negative written as - 0.
  `static void`
  `writeVPNnumber(DataOutput out, long v)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### UTF8

    public static final Charset UTF8

- ## Constructor Details

  - ### DataIO

    public DataIO()

- ## Method Details

  - ### decodeUTF8

    public static String decodeUTF8(ByteBuffer in, int length)

  - ### writeUTFv

    public static void writeUTFv(String string, DataOutput out) throws IOException
    Similar to writeUTF, but ok for strings > 32K bytes long and better for strings < 127 string utf-8 length must be ≤ Integer.MAX_VALUE - 1
    Parameters:
      `string` - the string to write
      `out` - the output sink
    Throws:
      `IOException` - passthru

  - ### readUTFv

    public static String readUTFv(DataInput in) throws IOException
    Throws:
      `IOException`

  - ### lengthUTFv

    public static long lengthUTFv(String string) throws UnsupportedEncodingException
    Throws:
      `UnsupportedEncodingException`

  - ### writeShort

    public static void writeShort(DataOutput out, int v) throws IOException
    DataOutputStream writeShort with checking of argument
    Parameters:
      `out` - the output sink
      `v` - the value to write
    Throws:
      `IOException` - passthru

  - ### writeByte

    public static void writeByte(DataOutput out, int v) throws IOException
    DataOutputStream writeByte with checking of argument
    Parameters:
      `out` - output sink
      `v` - the value to write
    Throws:
      `IOException` - passthru

  - ### writeUnsignedByte

    public static void writeUnsignedByte(DataOutput out, int v) throws IOException
    Write lower 8 bits
    Parameters:
      `out` - output sink
      `v` - the value to write
    Throws:
      `IOException` - passthru

  - ### writeVPNnumber

    public static void writeVPNnumber(DataOutput out, int v) throws IOException
    write a positive or negative number, optimized for fewer bytes near 0 sign put in low order bit, rest of number converted to positive and shifted left 1 max negative written as - 0.
    Parameters:
      `out` - output sink
      `v` - the value to write
    Throws:
      `IOException` - passthru

  - ### writeVPNnumber

    public static void writeVPNnumber(DataOutput out, long v) throws IOException
    Throws:
      `IOException`

  - ### lengthVPNnumber

    public static int lengthVPNnumber(int v)

  - ### lengthVPNnumber

    public static int lengthVPNnumber(long v)

  - ### writeVnumber

    public static void writeVnumber(DataOutput out, int v) throws IOException
    Write a positive number with the fewest bytes possible up to 127 written as a byte high order bit on means get another byte Note: value treated as unsigned 32 bit int
    Parameters:
      `out` - output sink
      `v` - the value to write
    Throws:
      `IOException` - passthru

  - ### lengthVnumber

    public static int lengthVnumber(int v)

  - ### readVnumber

    public static int readVnumber(DataInput in) throws IOException
    Throws:
      `IOException`

  - ### writeVnumber

    public static void writeVnumber(DataOutput out, long v) throws IOException
    Write a positive long with the fewest bytes possible; up to 127 written as a byte, high order bit on means get another byte.
    Parameters:
      `out` - output sink
      `v` - the value to write is never negative
    Throws:
      `IOException` - passthru

  - ### lengthVnumber

    public static int lengthVnumber(long v)

  - ### readVlong

    public static long readVlong(DataInput in) throws IOException
    Throws:
      `IOException`

  - ### readRestOfVlong

    public static long readRestOfVlong(DataInput in, int firstByte) throws IOException
    Throws:
      `IOException`

  - ### writeByteArray

    public static void writeByteArray(DataOutput out, byte[] v) throws IOException
    Throws:
      `IOException`

  - ### readByteArray

    public static byte[] readByteArray(DataInput in) throws IOException
    Throws:
      `IOException`

  - ### writeIntArray

    public static void writeIntArray(DataOutput out, int[] v) throws IOException
    write array preceded by its length
    Parameters:
      `out` - output sink
      `v` - the value to write
    Throws:
      `IOException` - passthru

  - ### readIntArray

    public static int[] readIntArray(DataInput in) throws IOException
    Throws:
      `IOException`

  - ### writeIntArrayDelta

    public static void writeIntArrayDelta(DataOutput out, int[] v) throws IOException
    Write delta encoded value, for increasing values
    Parameters:
      `out` - output sink
      `v` - the value to write
    Throws:
      `IOException` - passthru

  - ### readIntArrayDelta

    public static int[] readIntArrayDelta(DataInput in) throws IOException
    Throws:
      `IOException`

  - ### writeLongArray

    public static void writeLongArray(DataOutput out, long[] v) throws IOException
    Throws:
      `IOException`

  - ### readLongArray

    public static long[] readLongArray(DataInput in) throws IOException
    Throws:
      `IOException`

  - ### writeLongArrayDelta

    public static void writeLongArrayDelta(DataOutput out, long[] v) throws IOException
    Throws:
      `IOException`

  - ### readLongArrayDelta

    public static long[] readLongArrayDelta(DataInput in) throws IOException
    Throws:
      `IOException`

  - ### readUnsignedByte

    public static int readUnsignedByte(DataInput in) throws IOException
    Throws:
      `IOException`